import sys
import jarray
import java
from java.lang import String
from java.lang import Object
from java.util.zip import ZipFile
from java.util import ArrayList
from java.lang import StringBuffer
from java.io import InputStreamReader
from java.lang import StringBuffer
from com.ibm.wbiserver.common.mbean import ExportableArtifact
import com.ibm.wbiservers.customization.msg.MessageHelper
import javax.management as mgmt 

def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split(" ")
        else:
                tmpList = inStr.split("\n")  #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();        #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef
errorCode = ""
errorInfo = ""

# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2005, 2006. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT
#
#  Common Procedures for Import Artifacts Scripts
#
#  The following global constants and variables have to be declared and set in the scripts that include these common procedures:
#    
#    Error codes:
#    	ZIPFILE_NOT_FOUND                 
#    Component substitution text:
#    	COMPONENT  {component type}
#    Internal switches:
#    	debugOutFlag {1 = full debug trace output; 
#                     0 = no sysout output unless error and nlsEnabledFlag is off}
#
#       nlsEnabledFlag {1 = NLS enabled, default, requires customization.jar to be present in <washome>\lib;
#                       0 = sysout will be used for errors}
#
#----------------------------------------------------------------------------------------------------------

#-----------------------------------------------------------------
#-- Proc: debugOut
#   Conditionally write non-globalized debug output to system out
#     note: flag is set in main routine (end of this file)
#
#  Params:
#    sOut  String to be written to systemout if debugOutFlag is 1
#-----------------------------------------------------------------
def debugOut ( sOut ):
    global debugOutFlag

    debugOutFlag = 0
    if (debugOutFlag == 1):
        print sOut
    #endIf 
#endDef 

#-------------------------------------------------------------
#-- Proc: importArtifacts
#
# Imports artifacts for contained in the specified ZIP file. 
# Params:
#   mBeanObj          - pointer to MBean object
#   zipfileName       - zipfile containing artifacts
#   usrdId            - user 
# 
#------------------------------------------------------------

def importArtifacts ( mBeanObj, zipfileName, userId ):

        global AdminControl
        global ZIPFILE_NOT_FOUND
        global COMPONENT

        msg = "****---> importArtifacts " + mBeanObj.toString() + " " + zipfileName + " " + userId
        debugOut(msg)

        zipnameStr = String( zipfileName )
        try:
                _excp_ = 0
                zipFile = ZipFile( zipnameStr ) 
                _excp_ = 0 #reset (in case of nested exceptions)
        except:
                _type_, _value_, _tbck_ = sys.exc_info()
                result = str(_value_)
                _excp_ = 1
        #endTry 
        if (_excp_ ):
                exceptionExit(result )
        #endIf 
        zipname = zipFile.getName()
        debugOut("ZipFile name: "+zipname )
        entries = zipFile.entries()
        artifactList = ArrayList(  ) 
        relFileName = StringBuffer(  )
        while (entries.hasMoreElements()):
                entry = entries.nextElement()
                _J2J_bracket_ = entry.isDirectory()
                if (_J2J_bracket_ ):
                        relFileName.append(entry.getName())
                        relFileName.append(java.io.File.separator)
                        temprfnstr = java.lang.String(relFileName)
                        debugOut("Directory name: ["+temprfnstr+" toString]" )
                else:
                        relStr = String(entry.getName())
                        debugOut("Entry name: " + relStr.toString())
                        relFileName.append(relStr)
                        try:
                                _excp_ = 0
                                inputstream = zipFile.getInputStream(entry)
                                result = _J2J_bracket_
                                _excp_ = 0 #reset (in case of nested exceptions)
                        except:
                                _type_, _value_, _tbck_ = sys.exc_info()
                                result = str(_value_)
                                _excp_ = 1
                        #endTry 
                        if (_excp_ ):
                                exceptionExit(result )
                        #endIf 
                        charEncoding = "utf-8"
                        try:
                                _excp_ = 0
                                inReader = InputStreamReader( inputstream, charEncoding )
                                result = _J2J_bracket_
                                _excp_ = 0 #reset (in case of nested exceptions)
                        except:
                                _type_, _value_, _tbck_ = sys.exc_info()
                                result = str(_value_)
                                _excp_ = 1
                        #endTry 
                        if (_excp_ ):
                                exceptionExit(result )
                        #endIf 
                        buffer = jarray.zeros(1024, "c")
                        strbuffer = StringBuffer(  ) 
                        len = inReader.read(buffer, 0, 1024)
                        while (len > 0):
                                strbuffer.append(buffer, 0, len)
                                len = inReader.read(buffer, 0, 1024)
                        #endWhile 
                        _J2J_bracket_ = relFileName.toString()
                        exportArtifact = ExportableArtifact( _J2J_bracket_, strbuffer.toString() ) 
                        artifactList.add( exportArtifact )
                        relFileName = StringBuffer(  ) 
                        inputstream.close()
                        inReader.close()
                #endElse 
        #endWhile 
        zipFile.close()
        userIdStr = String( userId ) 
        parms = [userIdStr,artifactList]

        signature = ["java.lang.String","java.util.List"]
        _excp_ = 0
        try:
            _excp_ = 0
            out = AdminControl.invoke_jmx(mBeanObj, "importArtifacts", parms, signature )
            result = out
            _excp_ = 0 #reset (in case of nested exceptions)
        except:
            _type_, _value_, _tbck_ = sys.exc_info()
            print "_type_"
            print _type_
            print "_value_"
            print _value_
            print "_tbck_"
            print _tbck_
            result = str(_type_)
            _excp_ = 1
        #endTry 
        if (_excp_ ):
                exceptionExit(result )
        #endIf 
        debugOut("****<--- importArtifacts" )
        return 
#endDef 


#-------------------------------------------------------------------------------
#--- Proc: exceptionExit{}
#    write out propogated error exceptions, via nls message if enabled and exit
#-------------------------------------------------------------------------------

def exceptionExit ( errorString ):
        global nlsEnabledFlag

        if (nlsEnabledFlag == 1):
                # CWSTM0024E An exception was encountered while performing import {0}
                printNLSText("CWSTM0024E", [errorString] )
        else:
                print ""
                print ">>> "+errorString
                print ""
        #endElse 
        sys.exit()
#endDef 

#-------------------------------------------------------------
#-- Proc: errorExit 
#    exit script with final message
#-------------------------------------------------------------
def errorExit ( exitCode ):
    global nlsEnabledFlag

    errorMsg = "Ending Script execution with error code: %i" % exitCode
    debugOut(errorMsg)
    if (nlsEnabledFlag == 1):
        # CWSTM0025E Artifacts cannot be imported due to the folowing error {0}
        printNLSText("CWSTM0025E", [exitCode] )
    else:
        print ""
        print ">>> Error exit code: "+exitCode
        print ""
    #endElse 
    sys.exit()
#endDef 

#-------------------------------------------------------------
#-- Proc: mBeanErrorExit 
#    exit script with final message
#-------------------------------------------------------------
def mBeanErrorExit (  ):
    global nlsEnabledFlag

    if (nlsEnabledFlag == 1):
        printNLSText("CWSTM0056E", [] )
    else:
        print ""
        print ">>> The operation could not be complete as the business rule or selector MBean can not be located."
        print ""
    #endElse 
    sys.exit()
#endDef 

#-------------------------------------------------------------
#-- Proc: getNLSText
#
# Takes a message key and turns it into a localised message.
# params:
#   key		the message key
#   inserts	a list of strings to insert into the message
# returns a localised message.
#------------------------------------------------------------
def getNLSText ( key, inserts ):
        insertArray = jarray.zeros(len(inserts), Object)
        x = 0  
        while ( x < len(inserts)  ):  
                insertArray[x] = inserts[x]
                x += 1  
        #endWhile  

        return com.ibm.wbiservers.customization.msg.MessageHelper.getMessage( key, insertArray )
#endDef 

#-------------------------------------------------------------
#-- Proc: printNLSText
#    sets localMessage and writes it to system out
#-------------------------------------------------------------
def printNLSText ( key, inserts ):
        localMessage = getNLSText(key, inserts )
        print localMessage
#endDef 

